(define (domain aip-teaching)
  (:types
    student topic - object
  )

  (:predicates
    (too-many-lessons-missed ?s - student)
    (practical-level1-achieved ?s - student ?t - topic)
    (practical-level2-achieved ?s - student ?t - topic)
    (practical-level3-achieved ?s - student ?t - topic)
    (theoretical-level1-achieved ?s - student ?t - topic)
    (theoretical-level2-achieved ?s - student ?t - topic)
    (theoretical-level3-achieved ?s - student ?t - topic)
    (exercise-solved ?s - student ?t - topic)
  )

  (:action learn-practical-level1
    :parameters 
      (?s - student ?t - topic)
    :precondition
      (and)
    :effect
      (practical-level1-achieved ?s ?t)
  )

  (:action learn-practical-level2
    :parameters 
      (?s - student ?t - topic)
    :precondition
      (practical-level1-achieved ?s ?t)
    :effect
      (practical-level2-achieved ?s ?t)
  )

  (:action learn-practical-level3
    :parameters 
      (?s - student ?t - topic)
    :precondition
      (and
        (practical-level2-achieved ?s ?t)
        (not (too-many-lessons-missed ?s))
      )
    :effect
      (practical-level3-achieved ?s ?t)
  )

  (:action learn-theoretical-level1
    :parameters 
      (?s - student ?t - topic)
    :precondition
      (and)
    :effect
      (theoretical-level1-achieved ?s ?t)
  )

  (:action learn-theoretical-level2
    :parameters 
      (?s - student ?t - topic)
    :precondition
      (theoretical-level1-achieved ?s ?t)
    :effect
      (theoretical-level2-achieved ?s ?t)
  )

  (:action learn-theoretical-level3
    :parameters 
      (?s - student ?t - topic)
    :precondition
      (and
        (theoretical-level2-achieved ?s ?t)
        (not (too-many-lessons-missed ?s))
      )
    :effect
      (theoretical-level3-achieved ?s ?t)
  )

  (:action learn-extra-hard
    :parameters
      (?s - student)
    :precondition
      (and)
    :effect
      (not (too-many-lessons-missed ?s))
  )

  (:action solve-exercise
    :parameters
      (?s - student ?t - topic)
    :precondition
      (or
        (and
          (theoretical-level3-achieved ?s ?t)
          (practical-level1-achieved ?s ?t)
        )
        (and
          (theoretical-level2-achieved ?s ?t)
          (practical-level3-achieved ?s ?t)
        )
      )
    :effect
      (exercise-solved ?s ?t)
  )
)